/*
 * Copyright (c) 1988 University College London
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation,
 * advertising materials, and other materials related to such
 * distribution and use acknowledge that the software was developed
 * by the Department of Computer Science, University College London.
 * The name of the University may not be used to
 * endorse or promote products derived from this software without
 * specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

/* Data structures used in the osimic program */

#include "objectS.h"

#define ATTRLEN 32
#define POSLEN  64
#define MSGLEN  64


typedef struct AttrPairs
{
    struct AttrPairs  *Next;    /* linked list */
    char   attr_type  [ATTRLEN];
    char   attr_value [ATTRLEN];
} AttrPairs;



typedef struct PositionD
{
    char  pos_type  [POSLEN];
    char  pos_value [POSLEN];
} PositionD;



typedef struct MIBposition
{
    ManagedObjectS  mobj;
    MO_ID  *objinst;
    MO_ID  *subords;
} MIBposition;



typedef enum ErrType
{
    noError,
    objectDoesNotExist,
    noParentObject,
    noSubordinateObjects,
    noSuchEntry,
    noAttributes,
    objectNotModifiable,
    attributeNotModifiable,
    outOfMemory,
    fatalError,
    hostNotSupported,
    noMgmtConnection,
    illegalOperation
} ErrType;



typedef struct Error
{
    ErrType  err_type;
    char     err_msg [MSGLEN];
} Error;
