/* The MO_ID structure was used in the previous CMIP version to
 * represent a managed object ID i.e. a name. In fact a linked list
 * of them (RDNs) is used. A RDN can have an Integer, String
 * or Null value. If value=Null then rdnlen = 0, if value=Integer
 * then rdnval[0] = 0 and the value is stored in rdnval[1-4]
 * and if value=String then rdnval[0] = 1 and the value starts
 * at rdnval[1] (max value length is 9 bytes).
 * It is retained here for compatibility reasons.
 */

typedef struct MO_ID
{
    struct MO_ID *  Next;	/* next ID component (RDN) */
    OIDentifier	    rdntype;
    int     rdnlen;		/* value length */
    char    rdnval[10];		/* value */
}  MO_ID;


RDN	moid2rdn ();
DN	moid2dn ();
MO_ID * rdn2moid ();
MO_ID * dn2moid ();
char  * dn2str ();
void	moid_print ();
void	moid_free ();
