/*
 * Copyright (c) 1988 University College London
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation,
 * advertising materials, and other materials related to such
 * distribution and use acknowledge that the software was developed
 * by the Department of Computer Science, University College London.
 * The name of the University may not be used to
 * endorse or promote products derived from this software without
 * specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

/* Simplified definitions for managed object attributes as in the SMI doc,
 * used by client processes
 */

#include "isode/isoaddrs.h"
#include "smi.h"

#define HOSTLEN     16
#define TIMELEN     20

#define SELECTLEN   16
#define NADDRLEN    32


typedef char NSAPaddrS [NADDRLEN];


typedef struct NAddrHostMap
{
    NSAPaddrS   naddr;
    char        host [HOSTLEN];
} NAddrHostMap;


typedef struct TSAPaddrS
{
    char        tsel [SELECTLEN];
    int         tsel_len;
    NSAPaddrS   naddr;
} TSAPaddrS;


typedef struct SSAPaddrS
{
    char        ssel [SELECTLEN];
    int         ssel_len;
    TSAPaddrS   taddr;
} SSAPaddrS;


typedef struct PSAPaddrS
{
    char        psel [SELECTLEN];
    int         psel_len;
    SSAPaddrS   saddr;
} PSAPaddrS;


typedef struct TSAPs
{
    struct TSAPs  *Next;
    TSAPaddrS     taddr;
} TSAPs;


typedef struct destinationS
{
    struct destinationS  *Next;
    int type;
#   define RCI_DEST_PSAP 0
#   define RCI_DEST_AEI  1
#   define RCI_DEST_FD   2
    union {
	int fd;
	struct PSAPaddrS psap;
	AEI aei;
    } un;
#   define Fd_dest un.fd
#   define Psap_dest un.psap
#   define Aei_dest un.aei
} destinationS;
