--
-- Copyright (c) 1988 University College London
-- All rights reserved.
--
-- Redistribution and use in source and binary forms are permitted
-- provided that the above copyright notice and this paragraph are
-- duplicated in all such forms and that any documentation,
-- advertising materials, and other materials related to such
-- distribution and use acknowledge that the software was developed
-- by the Department of Computer Science, University College London.
-- The name of the University may not be used to
-- endorse or promote products derived from this software without
-- specific prior written permission.
-- THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
-- IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
-- WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
--

-- mabort.py - pepy source for user information in M-ABORT

-- By George Pavlou, April 1990


CMIPAbort
{ joint-iso-ccitt ms(9) cmip(1) version1(1) aAbortUserInfo(2) }
DEFINITIONS ::=

%{
#include <stdio.h>
#include <isode/rosap.h>
#include "msap.h"
%}

PREFIXES encode decode print

BEGIN

ENCODER build

CMIPAbortInfo [[P struct MSAPabort *]] ::= SEQUENCE
	{
	abortSource	[0] IMPLICIT CMIPAbortSource [[p &parm -> ma_source]],
	userinfo	[1] EXTERNAL [[p parm -> ma_info]]
				OPTIONAL << parm -> ma_info >>
	}

DECODER parse

CMIPAbortInfo [[P struct MSAPabort *]] ::= SEQUENCE
	{
	abortSource	[0] IMPLICIT CMIPAbortSource [[p &parm -> ma_source]],
	userinfo	[1] EXTERNAL [[p &parm -> ma_info]] OPTIONAL
	}

SECTIONS build parse none

CMIPAbortSource [[P int *]] ::= ENUMERATED [[i *parm]]
	{
	cmiseServiceUser	(0),
	cmiseServiceProvider	(1)
	}

END

%{

/* VARARGS2 */

static void  advise (what, fmt, a, b, c, d, e, f, g, h, i, j)
char  *what, *fmt, *a, *b, *c, *d, *e, *f, *g, *h, *i, *j;
{
    (void) fflush(stdout);
    (void) fprintf(stderr, "libmsap: ");
    (void) fprintf(stderr, fmt, a, b, c, d, e, f, g, h, i, j);
    if (what)
	(void) fputc(' ', stderr), perror(what);
    else
	(void) fputc('\n', stderr);
    (void) fflush(stderr);
}

%}
