/*
 * Copyright (c) 1988 University College London
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation,
 * advertising materials, and other materials related to such
 * distribution and use acknowledge that the software was developed
 * by the Department of Computer Science, University College London.
 * The name of the University may not be used to
 * endorse or promote products derived from this software without
 * specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

/* moidcmp.c - compare two MO_IDs, return 0 if different */

/*
 * By Simon Walton, October 1988
 */

#include <stdio.h>
#include "isode/rosap.h"
#include "msap.h"

moid_cmp(p, q)
MO_ID * p, * q;
{
int i;
if (p == NULL || q == NULL) return (p == q);
if (
	(oid_cmp(&p -> rdntype, &q -> rdntype) == 1) ||
	(i = p -> rdnlen) != q -> rdnlen ||
	(i && bcmp(p -> rdnval, q -> rdnval, i) )
   ) return (0);
return (moid_cmp(p -> Next, q -> Next));
}
