/*
 * Copyright (c) 1988 University College London
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation,
 * advertising materials, and other materials related to such
 * distribution and use acknowledge that the software was developed
 * by the Department of Computer Science, University College London.
 * The name of the University may not be used to
 * endorse or promote products derived from this software without
 * specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

/* reads the configuration file for participating hosts */

/*
 * By George Pavlou, October 1988
 */

#include <stdio.h>
#include "config.h"
#include "defs.h"

#define BUFLEN 80


int  getconfig (hosts, nofhosts)
char *hosts[];
int  *nofhosts;
{
    FILE *fp;
    char buf[BUFLEN+1], c, *calloc();

    if ((fp = fopen(strcat(ETCDIR, "mis.config"), "r")) == (FILE *) NULL)
	return (NOTOK);

    *nofhosts = 0;
    while (fscanf(fp, "%s", buf) != EOF) {
	if (buf[0] == '#') {		/* comment line: ignore */
	    while ((c = getc(fp)) != '\n');
	    continue;
	}
	hosts[*nofhosts] = calloc(1, sizeof(buf)+1);
	strcpy(hosts[(*nofhosts)++], buf);
    }

    fclose(fp);
    return (OK);
}
