/*
 * Copyright (c) 1988 University College London
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation,
 * advertising materials, and other materials related to such
 * distribution and use acknowledge that the software was developed
 * by the Department of Computer Science, University College London.
 * The name of the University may not be used to
 * endorse or promote products derived from this software without
 * specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

/* creates the MIB schema for display in osimic */

/*
 * By George Pavlou, October 1988
 */

#include <stdio.h>

static char  *schema [] = {
    "       Management Information Base Tree:\n",
    "\n",
    "                  ManagedSystem\n",
    "                        |\n",
    "               +-----------------+\n",
    "               |                 |\n",
    "        T-LayerSubsystem   ReportControl\n",
    "               |\n",
    "               |\n",
    "        T-LayerEntity\n",
    "               |\n",
    "      +-----------------+\n",
    "      |                 |\n",
    "ReportControl   T-EntityInvocation\n",
    "                        |\n",
    "               +-----------------+\n",
    "               |                 |\n",
    "     T-ConnectionEndpoint CounterThreshold\n",
    "               |\n",
    "               |\n",
    "        CounterThreshold\n",
    "\n\n"
};
#define LINES   22

#define LINELEN 44      /* including '\n' and terminating '\0' */



char  *create_schema ()
{
    char *buf, *malloc();
    int line;

    if ((buf = malloc(LINES*LINELEN)) == (char *) NULL)
	return ((char *) NULL);

    *buf = '\0';

    for (line = 0; line < LINES; line++) {
	strcat(buf, schema[line]);
    }

    return (buf);
}
